class Branch {
  PVector location;
  ArrayList<Branch> children = new ArrayList<Branch>();

  int depth = 0;
  float branchLength;
  float ratio = 0.7;
  float strokeWeightValue; 
  float angle;
  float yaw;

  float branchingLottery;
  float raiseProb;

  float growthPercentage;
  boolean isGrowable = false;
  boolean isAging = true;
  boolean isCursor = false;

  color branchColor = color(0, 0, 0);

  float age = 1;


  public Branch(float angle, float yaw, int depth, float raiseProb) {
    this.location = new PVector(0, 0, 0);
    this.angle = angle;
    this.depth = depth;
    this.yaw = yaw;
    this.raiseProb = raiseProb;
    this.branchColor = prob2color(raiseProb);
    //this.branchingLottery = raiseProb/2+0.5f;
    this.branchingLottery = max(raiseProb, 0.5);

    //println("mainBranch.branchingLottery = "+branchingLottery);
    growthPercentage = 0;
  }


  public void addChild(float angle_child, float yaw_child) {
    children.add(new Branch(angle+angle_child, yaw+yaw_child, depth+1, raiseProb));
  }

  public void addChild_NC() {
    children.add(new Branch(angle, yaw, depth, raiseProb));
  }


  public void addBranches(Branch newBranch) {
    updateBranchDepth(newBranch, depth);
    children.add(newBranch);
  }

  public void updateBranchDepth(Branch branch, int depth) {
    branch.depth +=depth;
    for (int i  = 0; i < branch.children.size(); i++) {
      updateBranchDepth( branch.children.get(i), depth);
    }
  }

  public void loadRaiseProb(float raiseProb) {
    this.raiseProb = raiseProb;
    this.branchingLottery = raiseProb/2+0.5f;
    this.branchColor = prob2color(raiseProb);
    //println("branchingLottery = "+branchingLottery);
    for (int i  = 0; i < children.size(); i++) {
      children.get(i).loadRaiseProb(raiseProb);
    }
  }


  //black out this branch and its children
  public void blackOut() {
    if (ifBlackOldBranches) {
      this.branchColor = color(0, 0, 0);
    }
    this.isAging = false;
    for (int i  = 0; i < children.size(); i++) {
      children.get(i).blackOut();
    }
  }

  //black out this branch
  public void blackOutSingle() {
    this.branchColor = color(0, 0, 0);
    this.isAging = false;
  }

  public color prob2color(float raiseProb) {
    //return color(255*max(raiseProb-0.5,0),255*max(1-raiseProb-0.5,0),0);
    if (raiseProb>0.5) {
      return redColor;
    } else {
      return greenColor;
    }
  }
}