class Tree {
  PVector location;
  Branch mainBranch;
  Branch root;
  float goldenRatio = 0.61803398875f;
  float mainBranchLength = height/10;
  float raiseProbability = goldenRatio;
  float mainStrokeWeightValue = 10;
  int depth;

  float agingRate = 1.0001;

  public Tree(float x, float y, float z, int depth, float gerenateAng, float gerenateYaw, float raiseProbability) {

    this.raiseProbability = raiseProbability;

    this.depth = depth;
    location = new PVector(x, y, z);
    root = new Branch(0,0, 0, 0.5);
    root.branchLength = mainBranchLength;
    root.strokeWeightValue = mainStrokeWeightValue;
    root.location = location;

    mainBranch = new Branch(gerenateAng,gerenateYaw, 0, root.raiseProb);
    mainBranch.branchLength = mainBranchLength;
    mainBranch.strokeWeightValue = mainStrokeWeightValue;
    mainBranch.location = new PVector(x, y-mainBranchLength, 0);


    mainBranch.growthPercentage = 1;

    root.children.add(mainBranch);
    root.growthPercentage = 1;
    root.isGrowable = true;
  }

  public void buildTree() {
    //buildBranch(mainBranch);
    float ang = 0.3;//random(0,0.6);

    mainBranch.addChild(-ang,0);
    mainBranch.addChild(ang,0);


    mainBranch.children.get(0).loadRaiseProb(raiseProbability); //right
    mainBranch.children.get(1).loadRaiseProb(1-raiseProbability);  //left


    //mainBranch.children.get(0).depth *= 0.6; //right
    //mainBranch.children.get(1).depth *= 1;  //left

    buildBranch(mainBranch.children.get(0));
    buildBranch(mainBranch.children.get(1));
  }

  public void drawTree() {
    //drawBranch(root);
  }

  public void drawTreeWithTurbulence(float turbulence) {
    translate(root.location.x, root.location.y,  root.location.z);
    //drawBranchWithTurbulence(root, turbulence);
  }



  public void buildBranch(Branch branch) {
    if (branch.depth<this.depth) {

      if (random(1.0)<branch.branchingLottery) {
        float ang = 0.3;//random(0,0.6);
        
        if(random(1.0)<0.5){
          branch.addChild(0,-ang);
          branch.addChild(0,ang);
        }
        else{
        branch.addChild(-ang,0);
        branch.addChild(ang,0);
        }
        
      } else {  //grow as the same length
        branch.addChild_NC();
      }
    }

    for (int i =  0; i<branch.children.size (); i++) {
      buildBranch(branch.children.get(i));
    }
  }




  //public void drawBranch(Branch branch) {
  //  if (branch.children.size()>0) {
  //    for (int i =  0; i<branch.children.size (); i++) {
  //      strokeWeight(branch.children.get(i).strokeWeightValue); 
  //      line(branch.location.x, branch.location.y, branch.children.get(i).location.x, branch.children.get(i).location.y);
  //      drawBranch(branch.children.get(i));
  //    }
  //  }
  //}



  //public void drawBranchWithTurbulence(Branch branch, float turbulence) {
  //  if (branch.children.size()>0) {
  //    for (int i =  0; i<branch.children.size (); i++) {
  //      pushMatrix();
  //      strokeWeight(branch.children.get(i).strokeWeightValue); 
  //      rotate(turbulence);
  //      line(0, 0, branch.children.get(i).location.x-branch.location.x, branch.children.get(i).location.y-branch.location.y);
  //      translate(branch.children.get(i).location.x-branch.location.x, branch.children.get(i).location.y-branch.location.y);
  //      drawBranchWithTurbulence(branch.children.get(i), turbulence);
  //      popMatrix();
  //    }
  //  }
  //}

  public void drawTreeAnim(float process) {
    drawBranchAnim(root, process);
  }

  public void drawBranchAnim(Branch branch, float process) {

    if (branch.children.size()>0) {
      for (int i =  0; i<branch.children.size (); i++) {
        float currentRatio = pow(branch.ratio, branch.children.get(i).depth)*branch.children.get(i).age;


        //update age
        if (branch.children.get(i).isAging) {
          branch.children.get(i).age*=agingRate;
        }


        branch.children.get(i).strokeWeightValue = mainStrokeWeightValue*currentRatio;
        branch.children.get(i).branchLength = mainBranchLength*currentRatio;



        branch.children.get(i).location.x = branch.location.x+mainBranchLength*sin(branch.children.get(i).angle)*currentRatio;
        branch.children.get(i).location.y = branch.location.y-mainBranchLength*cos(branch.children.get(i).angle)*cos(branch.children.get(i).yaw)*currentRatio;
        branch.children.get(i).location.z = branch.location.z-mainBranchLength*cos(branch.children.get(i).angle)*sin(branch.children.get(i).yaw)*currentRatio;
        
        //if (!ifMovecam&&(!isDragging)&&dragEndFrame<frameCount-100) {

        //  if (branch.children.get(i).location.y+camY<20) {
        //    ifMovecam = true;
        //    camTargetX = cursorBranch.location.x-(width*0.618);
        //    camTargetY = (height-20)-cursorBranch.location.y;
        //    println("too high!  set target x = "+camTargetX+", y = "+camTargetY);
        //  }

        //  if (cursorBranch.location.y+camY>height) {
        //    ifMovecam = true;
        //    camTargetX = cursorBranch.location.x-(width*0.618);
        //    camTargetY = (height-20)-cursorBranch.location.y;

        //    println("too low!  set target x = "+camTargetX+", y = "+camTargetY);
        //  }
        //}




        strokeWeight(branch.children.get(i).strokeWeightValue); 

        if (branch.isGrowable) {
          stroke(branch.children.get(i).branchColor);
          line(branch.location.x, branch.location.y,branch.location.z, branch.location.x + branch.growthPercentage*(branch.children.get(i).location.x-branch.location.x), branch.location.y + branch.growthPercentage*(branch.children.get(i).location.y-branch.location.y), branch.location.z + branch.growthPercentage*(branch.children.get(i).location.z-branch.location.z));
          //text(""+branch.branchingLottery,branch.location.x+5, branch.location.y);

          if (ifShowTimeLines&&branch.isCursor) text("current", branch.location.x+5, branch.location.y, branch.location.z);

          if (ifStartGrow) {
            if (branch.growthPercentage<1) {
              branch.growthPercentage+=0.05;
            } else {
              branch.children.get(i).isGrowable = true;
            }
          }
        }
        drawBranchAnim(branch.children.get(i), process);
      }
    }
  }
}